/*
    This ist the sample code delivered with the UnRARDLL
    Package. I used this code to make a Win32 GUI App-
    lication that UnRARs files for FREE!!
    Dr. Trigon - 24.6.2004
*/
#define STRICT
#include <windows.h>
#include <stdio.h>
#include <ctype.h>
#include "unrar.h"
#include <string.h>
#include "gudrun.h"
#include "WinUnRAR_private.h"
#include "DialogBox.h"

// Windows ID's
#define TIME_RUNAPP    1
#define IDC_TEXT       2
#define ID_OK          3
#define ID_CANCEL      4

// UNRAR procedures
enum { EXTRACT, TEST, PRINT };

void ExtractArchive(char *ArcName,int Mode);
void ListArchive(char *ArcName);
void ShowComment(char *CmtBuf);
//void OutHelp(void);
void OutOpenArchiveError(int Error,char *ArcName);
void ShowArcInfo(unsigned int Flags,char *ArcName);
void OutProcessFileError(int Error);
int CALLBACK CallbackProc(UINT msg,LONG UserData,LONG P1,LONG P2);

// Windows procedures
int     WINAPI   WinMain (HINSTANCE, HINSTANCE, LPSTR, int);
LRESULT CALLBACK WinProc (HWND, UINT, WPARAM, LPARAM);
VOID    CALLBACK TimerProc (HWND, UINT, UINT, DWORD);
BOOL    CALLBACK InputBoxProc (HWND, UINT, WPARAM, LPARAM);
void             WinPrint (char*);
int              InputBox (HWND, LPCTSTR, LPCTSTR, UINT uType = 0);

//  Windows global variables
const char szClassName[ ] = "WinUnRAR_Class";
const char szAppName[ ] = "WinUnRAR";

char param[1];
char file[512];

HINSTANCE hThisApp;
HWND hwnd;
HWND hedtOutput;


void ExtractArchive(char *ArcName,int Mode)
{
  HANDLE hArcData;
  int RHCode,PFCode;
  char CmtBuf[16384];
  struct RARHeaderData HeaderData;
  struct RAROpenArchiveDataEx OpenArchiveData;
  char testBuf[1000];

  memset(&OpenArchiveData,0,sizeof(OpenArchiveData));
  OpenArchiveData.ArcName=ArcName;
  OpenArchiveData.CmtBuf=CmtBuf;
  OpenArchiveData.CmtBufSize=sizeof(CmtBuf);
  OpenArchiveData.OpenMode=RAR_OM_EXTRACT;
  hArcData=RAROpenArchiveEx(&OpenArchiveData);

  if (OpenArchiveData.OpenResult!=0)
  {
    OutOpenArchiveError(OpenArchiveData.OpenResult,ArcName);
    return;
  }

  ShowArcInfo(OpenArchiveData.Flags,ArcName);

  if (OpenArchiveData.CmtState==1)
    ShowComment(CmtBuf);

  RARSetCallback(hArcData,CallbackProc,(LONG)&Mode);

  HeaderData.CmtBuf=NULL;

  while ((RHCode=RARReadHeader(hArcData,&HeaderData))==0)
  {
    switch(Mode)
    {
      case EXTRACT:
        sprintf(testBuf, "\r\nExtracting %-45s\0",HeaderData.FileName);
        WinPrint(testBuf);
        break;
      case TEST:
        sprintf(testBuf, "\r\nTesting %-45s\0",HeaderData.FileName);
        WinPrint(testBuf);
        break;
    }
    PFCode=RARProcessFile(hArcData,(Mode==EXTRACT) ? RAR_EXTRACT:RAR_TEST,
                          NULL,NULL);
    if (PFCode==0)
      WinPrint("[Ok]\0");
    else
    {
      OutProcessFileError(PFCode);
      break;
    }
  }

  if (RHCode==ERAR_BAD_DATA)
    WinPrint("\r\nFile header broken\0");

  RARCloseArchive(hArcData);
}


void ListArchive(char *ArcName)
{
  HANDLE hArcData;
  int RHCode,PFCode;
  char CmtBuf[16384];
  struct RARHeaderDataEx HeaderData;
  struct RAROpenArchiveDataEx OpenArchiveData;
  char testBuf[1000];

  memset(&OpenArchiveData,0,sizeof(OpenArchiveData));
  OpenArchiveData.ArcName=ArcName;
  OpenArchiveData.CmtBuf=CmtBuf;
  OpenArchiveData.CmtBufSize=sizeof(CmtBuf);
  OpenArchiveData.OpenMode=RAR_OM_LIST;
  hArcData=RAROpenArchiveEx(&OpenArchiveData);

  if (OpenArchiveData.OpenResult!=0)
  {
    OutOpenArchiveError(OpenArchiveData.OpenResult,ArcName);
    return;
  }

  ShowArcInfo(OpenArchiveData.Flags,ArcName);

  if (OpenArchiveData.CmtState==1)
    ShowComment(CmtBuf);

  RARSetCallback(hArcData,CallbackProc,0);

  HeaderData.CmtBuf=CmtBuf;
  HeaderData.CmtBufSize=sizeof(CmtBuf);

  WinPrint("\r\nFiles:\0");
  WinPrint("\r\n-------------------------------------\0");
  while ((RHCode=RARReadHeaderEx(hArcData,&HeaderData))==0)
  {
    __int64 UnpSize=HeaderData.UnpSize+(((__int64)HeaderData.UnpSizeHigh)<<32);
    sprintf(testBuf, "\r\n%-45s [%Ld]\0",HeaderData.FileName,UnpSize);
    WinPrint(testBuf);
    if (HeaderData.CmtState==1)
      ShowComment(CmtBuf);
    if ((PFCode=RARProcessFile(hArcData,RAR_SKIP,NULL,NULL))!=0)
    {
      OutProcessFileError(PFCode);
      break;
    }
  }

  if (RHCode==ERAR_BAD_DATA)
    WinPrint("\r\nFile header broken\0");

  RARCloseArchive(hArcData);
}


void ShowComment(char *CmtBuf)
{
  char testBuf[1000];

  /*
  printf("\nComment:\n%s\n",CmtBuf);
  */

  /*
  sprintf(testBuf, "\r\nComment:\r\n%s\r\n",CmtBuf);
  strcat(szOutput, testBuf);

  SetWindowText(hedtOutput, szOutput);
  UpdateWindow(hwnd);
  */

  sprintf(testBuf, "\r\nComment:\r\n%s\r\n\0",CmtBuf);
  WinPrint(testBuf);
}


/*
void OutHelp(void)
{
  printf("\nWINUNRAR.   This is a simple example of UNRAR.DLL usage");
  printf("\n            Free Win32 UnRAR tool by Dr. Trigon\n");
  printf("\nSyntax:\n");
  printf("\nWINUNRAR X <Archive>     extract archive contents");
  printf("\nWINUNRAR T <Archive>     test archive contents");
  printf("\nWINUNRAR L <Archive>     view archive contents\n");
}
*/


void OutOpenArchiveError(int Error,char *ArcName)
{
  char testBuf[1000];

  switch(Error)
  {
    case ERAR_NO_MEMORY:
      WinPrint("\r\nNot enough memory\0");
      break;
    case ERAR_EOPEN:
      sprintf(testBuf, "\r\nCannot open %s\0",ArcName);
      WinPrint(testBuf);
      break;
    case ERAR_BAD_ARCHIVE:
      sprintf(testBuf, "\r\n%s is not RAR archive\0",ArcName);
      WinPrint(testBuf);
      break;
    case ERAR_BAD_DATA:
      sprintf(testBuf, "\r\n%s: archive header broken\0",ArcName);
      WinPrint(testBuf);
      break;
    case ERAR_UNKNOWN:
      WinPrint("Unknown error\0");
      break;
  }
}


void ShowArcInfo(unsigned int Flags,char *ArcName)
{
  char testBuf[1000];

  sprintf(testBuf, "\r\nArchive %s\r\n\0",ArcName);
  WinPrint(testBuf);
  sprintf(testBuf, "\r\nVolume:\t\t%s\0",(Flags & 1) ? "yes":"no");
  WinPrint(testBuf);
  sprintf(testBuf, "\r\nComment:\t%s\0",(Flags & 2) ? "yes":"no");
  WinPrint(testBuf);
  sprintf(testBuf, "\r\nLocked:\t\t%s\0",(Flags & 4) ? "yes":"no");
  WinPrint(testBuf);
  sprintf(testBuf, "\r\nSolid:\t\t%s\0",(Flags & 8) ? "yes":"no");
  WinPrint(testBuf);
  sprintf(testBuf, "\r\nNew naming:\t%s\0",(Flags & 16) ? "yes":"no");
  WinPrint(testBuf);
  sprintf(testBuf, "\r\nAuthenticity:\t%s\0",(Flags & 32) ? "yes":"no");
  WinPrint(testBuf);
  sprintf(testBuf, "\r\nRecovery:\t%s\0",(Flags & 64) ? "yes":"no");
  WinPrint(testBuf);
  sprintf(testBuf, "\r\nEncr.headers:\t%s\0",(Flags & 128) ? "yes":"no");
  WinPrint(testBuf);
  sprintf(testBuf, "\r\nFirst volume:\t%s\0",(Flags & 256) ? "yes":"no or older than 3.0");
  WinPrint(testBuf);
  sprintf(testBuf, "\r\n-------------------------------------\r\n\0");
  WinPrint(testBuf);
}


void OutProcessFileError(int Error)
{
  switch(Error)
  {
    case ERAR_UNKNOWN_FORMAT:
      WinPrint("Unknown archive format\0");
      break;
    case ERAR_BAD_ARCHIVE:
      WinPrint("Bad volume\0");
      break;
    case ERAR_ECREATE:
      WinPrint("File create error\0");
      break;
    case ERAR_EOPEN:
      WinPrint("Volume open error\0");
      break;
    case ERAR_ECLOSE:
      WinPrint("File close error\0");
      break;
    case ERAR_EREAD:
      WinPrint("Read error\0");
      break;
    case ERAR_EWRITE:
      WinPrint("Write error\0");
      break;
    case ERAR_BAD_DATA:
      WinPrint("CRC error\0");
      break;
    case ERAR_UNKNOWN:
      WinPrint("Unknown error\0");
      break;
  }
}


int CALLBACK CallbackProc(UINT msg,LONG UserData,LONG P1,LONG P2)
{
  char testBuf[1000];
  int retry = IDOK, res = 0;

  switch(msg)
  {
    case UCM_CHANGEVOLUME:
      if (P2==RAR_VOL_ASK)
      {
        /*
        printf("\nInsert disk with %s and press 'Enter' or enter 'Q' to exit ",(char *)P1);
        return(toupper(getchar())=='Q' ? -1:0);
        */
        sprintf(testBuf, "\r\nInsert disk with %s and press 'OK' or press 'Cancel' to exit ",(char *)P1);
        retry = MessageBox(hwnd, testBuf, szAppName, MB_OKCANCEL | MB_ICONQUESTION | MB_SYSTEMMODAL);
        return(retry==IDCANCEL ? -1:0);
      }
      return(0);
    case UCM_NEEDPASSWORD:
      /*
      printf("\nPassword required: ");
      gets((char *)P1);
      */
      res = InputBox(hwnd, "Password:", szAppName);
      if (res)
          strcat((char *)P1, (char*)res);
      return(0);
  }
  return(0);
}


// Main program function
//
int WINAPI WinMain (HINSTANCE hThisInstance,
                    HINSTANCE hPrevInstance,
                    LPSTR lpszArgument,
                    int nFunsterStil)

{
    MSG messages;            /* Here messages to the application are saved */
    WNDCLASSEX wincl;        /* Data structure for the windowclass */


    hThisApp = hThisInstance;

    if (strlen(lpszArgument)<=1)
    {
        //OutHelp();
        MessageBox(NULL, vstrcopy(FILE_DESCRIPTION, "\nVersion ", VER_STRING, "\nwritten by ", COMPANY_NAME, " [dr.trigon@surfeu.ch]", NULL), szAppName, MB_ICONINFORMATION | MB_TASKMODAL);
        return(0);
    }

    strncpy(param, lpszArgument, 1);

    for (int i=0;i<=(strlen(lpszArgument)-2);i++)
    {
        file[i] = lpszArgument[i+1];
    }    


    /* The Window structure */
    wincl.hInstance = hThisInstance;
    wincl.lpszClassName = szClassName;
    wincl.lpfnWndProc = WinProc;              /* This function is called by windows */
    wincl.style = CS_DBLCLKS;                 /* Catch double-clicks */
    wincl.cbSize = sizeof (WNDCLASSEX);

    /* Use default icon and mouse-pointer */
    wincl.hIcon = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hIconSm = LoadIcon (NULL, IDI_APPLICATION);
    wincl.hCursor = LoadCursor (NULL, IDC_ARROW);
    wincl.lpszMenuName = NULL;                 /* No menu */
    wincl.cbClsExtra = 0;                      /* No extra bytes after the window class */
    wincl.cbWndExtra = 0;                      /* structure or the window instance */
    /* Use Windows's default color as the background of the window */
    wincl.hbrBackground = (HBRUSH) COLOR_BACKGROUND;

    /* Register the window class, and if it fails quit the program */
    if (!RegisterClassEx (&wincl))
        return 0;

    /* The class is registered, let's create the program*/
    hwnd = CreateWindowEx (
           0,                   /* Extended possibilites for variation */
           szClassName,         /* Classname */
           vstrcopy((char*)szAppName, " v", VER_STRING, NULL),           /* Title Text */
           WS_OVERLAPPEDWINDOW, /* default window */
           CW_USEDEFAULT,       /* Windows decides the position */
           CW_USEDEFAULT,       /* where the window ends up on the screen */
           500,                 /* The programs width */
           300,                 /* and height in pixels */
           HWND_DESKTOP,        /* The window is a child-window to desktop */
           NULL,                /* No menu */
           hThisInstance,       /* Program Instance handler */
           NULL                 /* No Window Creation data */
           );

    /* Make the window visible on the screen */
    ShowWindow (hwnd, nFunsterStil);

    /* Run the message loop. It will run until GetMessage() returns 0 */
    while (GetMessage (&messages, NULL, 0, 0))
    {
        /* Translate virtual-key messages into character messages */
        TranslateMessage(&messages);
        /* Send message to WinProc */
        DispatchMessage(&messages);
    }

    /* The program return-value is 0 - The value that PostQuitMessage() gave */
    return messages.wParam;
}


// Function called by the Windows function DispatchMessage()
//
LRESULT CALLBACK WinProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
    //static HWND hedtOutput;
    static HFONT hFont;

    switch (message)                  /* handle the messages */
    {
        case WM_CREATE:
            // Schriften erstellen
            hFont = CreateFont(-11, 0,
                    0, 0,
                    FW_NORMAL,
                    FALSE,
                    FALSE,
                    FALSE,
                    DEFAULT_CHARSET,
                    OUT_DEFAULT_PRECIS,
                    CLIP_DEFAULT_PRECIS,
                    DEFAULT_QUALITY,
                    FIXED_PITCH,
//                    "System");
                    NULL);

            // EditBox erstellen
            hedtOutput = CreateWindowEx(WS_EX_CLIENTEDGE,
                         "edit",
                         "",
                         WS_CHILD | WS_VISIBLE | WS_VSCROLL | WS_HSCROLL | ES_MULTILINE | ES_READONLY,
                         0, 0, 10, 10,
                         hwnd,
                         NULL,
                         ((LPCREATESTRUCT) lParam) -> hInstance,
                         NULL);
            // Schriftart von EditBox wechseln
            SendMessage(hedtOutput, WM_SETFONT, (WPARAM)hFont, TRUE);

            // Timer fr verzgerten Programmstart
            SetTimer(hwnd, TIME_RUNAPP, 500, TimerProc);

            // Programm ohne verzgerung SOFORT starten
            //TimerProc(hwnd, 0, TIME_RUNAPP, 0);

            break;
        case WM_SIZE:
            MoveWindow(hedtOutput, 0, 0, LOWORD(lParam), HIWORD(lParam), TRUE);
            break;
        case WM_DESTROY:
            // erzeugte Objekte wieder vernichten (Speicher freigeben)
            DeleteObject(hFont);

            PostQuitMessage (0);       /* send a WM_QUIT to the message queue */
            break;
        default:                      /* for messages that we don't deal with */
            return DefWindowProc (hwnd, message, wParam, lParam);
    }

    return 0;
}


// Callback function for the Timer
//
VOID CALLBACK TimerProc(
    HWND hwnd,	// handle of window for timer messages 
    UINT uMsg,	// WM_TIMER message
    UINT idEvent,	// timer identifier
    DWORD dwTime 	// current system time
   )
{
    KillTimer(hwnd, TIME_RUNAPP);

    switch(toupper(param[0]))
    {
        case 'X':
            ExtractArchive(file,EXTRACT);
            break;
        case 'T':
            ExtractArchive(file,TEST);
            break;
        case 'L':
            ListArchive(file);
            break;
//        case 'H':
//            OutHelp();
//            PostQuitMessage (0);
//            break;
        default:
            MessageBox(hwnd, "Error: invalid parameter.\nPlease reinstall the program.", szAppName, MB_ICONSTOP | MB_SYSTEMMODAL);
            PostQuitMessage (0);
    }

    /*
    // auf letzte Zeile scrollen
    SendMessage(hedtOutput, EM_LINESCROLL, 0, SendMessage(hedtOutput, EM_GETLINECOUNT, 0, 0));
    */

    return;
}


// Callback function for the InputBox()
//
BOOL CALLBACK InputBoxProc(HWND hwndDlg, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
    switch (uMsg)
    {
        case WM_INITDIALOG:
            SetFocus(GetDlgItem(hwndDlg, IDC_TEXT));
            break;
        case WM_COMMAND:
            if (LOWORD(wParam)==ID_CANCEL)
                EndDialog(hwndDlg, 0);

            if (LOWORD(wParam)==ID_OK)
            {
                char password[256];
                
                GetDlgItemText(hwndDlg, IDC_TEXT, password, sizeof(password));

                EndDialog(hwndDlg, (int)password);
            }    

            break;
    }

    return 0;
}


// "PRINT" funtion for Windows
//
void WinPrint(char* string)
{
  /*
  char string[] = "hallo\r\n\0";
  SendMessage(hedtOutput, EM_REPLACESEL, FALSE, (LPARAM)&string);
  */

  SendMessage(hedtOutput, EM_REPLACESEL, FALSE, (LPARAM)string);
}    


// InputBox() function
//
int InputBox(HWND hwnd, LPCTSTR lpText, LPCTSTR lpCaption, UINT uType)
{
    // DialogBox erstellen
    LPCSTR caption = lpCaption;
    LPCSTR font = "Tahoma";
    WORD fontSize = 8;

    usedBufferLength = sizeof(DLGTEMPLATE );
    totalBufferLength = usedBufferLength;

    dialogTemplate = (DLGTEMPLATE*)malloc(totalBufferLength);

    dialogTemplate->style = WS_CAPTION | DS_CENTER;

    if (font != NULL)
    {
        dialogTemplate->style |= DS_SETFONT;
    }

    dialogTemplate->x     = 10;
    dialogTemplate->y     = 10;
    dialogTemplate->cx    = 200;
    dialogTemplate->cy    = 60;
    dialogTemplate->cdit  = 0;

    dialogTemplate->dwExtendedStyle = 0;

    AppendData((void*)TEXT("\0"), 2);    // no menu
    AppendData((void*)TEXT("\0"), 2);    // no special class

    AppendString(caption);               // add the dialog's caption

    if (font != NULL)
    {
        AppendData(&fontSize, sizeof(WORD));
        AppendString(font);
    }

    // Label erstellen (static)
    WORD creationDataLength = 0;

    AddStandardComponent(0x0082,
                         lpText,
                         WS_VISIBLE,
                         0,
                         2 + 3,      // x
                         7,          // y
                         37,         // w
                         8,          // h
                         (WORD)-1);
    AppendData(&creationDataLength, sizeof(WORD));

    // Text erzeugen (editbox)
    AddStandardComponent(0x0081,
                         "",
                         WS_VISIBLE | ES_PASSWORD | WS_TABSTOP,
                         WS_EX_STATICEDGE,
                         45 + 3,     // x
                         7,          // y
                         131,        // w
                         11,         // h
                         IDC_TEXT);
    AppendData(&creationDataLength, sizeof(WORD));

    // Button erzeugen
    AddStandardComponent(0x0080,
                         "OK",
                         WS_VISIBLE | WS_TABSTOP | BS_DEFPUSHBUTTON,
                         0,
                         2 + 3,      // x
                         42,         // y
                         56,         // w
                         13,         // h
                         ID_OK);
    AppendData(&creationDataLength, sizeof(WORD));

    // Button erzeugen
    AddStandardComponent(0x0080,
                         "Cancel",
                         WS_VISIBLE | WS_TABSTOP,
                         0,
                         135 + 3,    // x
                         42,         // y
                         56,         // w
                         13,         // h
                         ID_CANCEL);
    AppendData(&creationDataLength, sizeof(WORD));

    // Dialog anzeigen
    int res = DialogBoxIndirect(hThisApp, dialogTemplate, hwnd, InputBoxProc);

    // Speicher wieder freigeben
    free(dialogTemplate);
    
    return res;
}


